﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class FullSequence : MonoBehaviour {
    // 0 = up
    // 1 = down
    // 2 = right
    // 3 = left
    public GameObject spawner;
    public GameObject arrowPrefab;
    int SIZE = 8;
    public int amountCorrect = 0;
    public GameObject[] arrows;
    public bool selectedSequence = true;
    public int numberInSequence;
    public float lifetime;
    GameObject healthManager;
    public GameObject[] Characters;
    int randomcharacter;
    GameObject spawnpoint;
    GameObject character;
    bool splashPlayed;
    Animator splash;
    AudioSource audio;
    public AudioClip[] notes;


    // Use this for initialization
    void Start () {
        audio = GetComponent<AudioSource>();
        splashPlayed = false;
        splash = GameObject.FindGameObjectWithTag("splash").GetComponent<Animator>();
        randomcharacter = Random.Range(0, 6);
        spawnpoint = GameObject.FindGameObjectWithTag("Respawn");
        character = Instantiate(Characters[randomcharacter], spawnpoint.transform.position, spawnpoint.transform.rotation) as GameObject;
        character.gameObject.GetComponent<characterMvement>().sequence = gameObject;
        //character.transform.parent = gameObject.transform;
        healthManager = spawner.GetComponent<sequenceSpawner>().healthManager;
        healthManager.GetComponent<healthDisplay>().UpdateHealth();
        lifetime = 0;
        SIZE = Random.Range(5 + spawner.GetComponent<sequenceSpawner>().sequencesDone / 8, 6 + spawner.GetComponent<sequenceSpawner>().sequencesDone / 4);
        Mathf.Clamp(SIZE, 5, 12);
        if (SIZE > 12) SIZE = 12;
        for (int i = 0; i < SIZE; i++)
        {
            arrows[i] = Instantiate(arrowPrefab, transform.position + new Vector3(i*0.75f, 0f, 0f), transform.rotation) as GameObject;
            arrows[i].transform.parent = gameObject.transform;
            arrows[i].GetComponent<Sequence>().arrownumber = Random.Range(0, 4);
        }
	}
	// Update is called once per frame
	void Update () {
        lifetime += Time.deltaTime;
     //   if (lifetime >= 16.25f && !splashPlayed)
     //   {
     //       splash.Play("watersplash", 0);
     //       splashPlayed = true;
     //   }
           
        if (lifetime >= 15f)
            SequenceFailed();
		if (selectedSequence)
        {
            if (Input.GetButtonDown("up"))
                ButtonIsPressed(0);
            if (Input.GetButtonDown("down"))
                ButtonIsPressed(1);
            if (Input.GetButtonDown("right"))
                ButtonIsPressed(2);
            if (Input.GetButtonDown("left"))
                ButtonIsPressed(3);
        }
        if (numberInSequence > 3)
        {
            for (int i = 0; i < SIZE; i++)
            {
                transform.GetChild(i).GetComponent<SpriteRenderer>().enabled = false;
            }
        }
        else
        {
            for (int i = 0; i < SIZE; i++)
            {
                transform.GetChild(i).GetComponent<SpriteRenderer>().enabled = true;
            }
        } 
    }

    void ButtonIsPressed(int x)
    {
        if (x == arrows[amountCorrect].GetComponent<Sequence>().arrownumber)
        {
            arrows[amountCorrect].GetComponent<Sequence>().pressed = true;
            amountCorrect++;
            PlayRandomSound();
            if (amountCorrect == SIZE)
                SequenceIsDone();
        }
        else
        {
            spawner.GetComponent<sequenceSpawner>().aSequenceIsSelected = false;
            for (int i = 0; i < amountCorrect; i++)
            {
                arrows[i].GetComponent<Sequence>().pressed = false;
            }
            amountCorrect = 0;        
        }
    }
    void SequenceIsDone()
    {
        spawner.GetComponent<sequenceSpawner>().aSequenceIsSelected = false;
        spawner.GetComponent<sequenceSpawner>().sequencesDone++;
        spawner.GetComponent<sequenceSpawner>().moveUp = true;
        spawner.GetComponent<sequenceSpawner>().n_sequences--;
        character.GetComponent<characterMvement>().SequencePlayed();
        Destroy(gameObject);
    }
    void SequenceFailed()
    {
        spawner.GetComponent<sequenceSpawner>().aSequenceIsSelected = false;
        spawner.GetComponent<sequenceSpawner>().moveUp = true;
        spawner.GetComponent<sequenceSpawner>().n_sequences--;
        spawner.GetComponent<sequenceSpawner>().health--;
        healthManager.GetComponent<healthDisplay>().healthnow = spawner.GetComponent<sequenceSpawner>().health;
        healthManager.GetComponent<healthDisplay>().UpdateHealth();
        Destroy(gameObject);
        if (spawner.GetComponent<sequenceSpawner>().health == 0)
        {
            spawner.GetComponent<sequenceSpawner>().GameOver();
            Time.timeScale = 0f;
        }

    }
    void PlayRandomSound()
    {
        float random;
        random = Random.Range(0.9f,1.1f);
        //audio.pitch = random;
        //audio.PlayOneShot(audio.clip);
    }
}
